unit DS1820_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls, Menus, Inifiles;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    MPort: TMenuItem;
    MCOM1: TMenuItem;
    MCOM2: TMenuItem;
    MCOM3: TMenuItem;
    MCOM4: TMenuItem;
    Panel1: TPanel;
    N1: TMenuItem;
    MClosePort: TMenuItem;
    MHelp: TMenuItem;
    MAbout: TMenuItem;
    N3: TMenuItem;
    MExit: TMenuItem;
    Label2: TLabel;
    EID: TEdit;
    Label3: TLabel;
    EName: TEdit;
    N2: TMenuItem;
    MCircuit: TMenuItem;
    Label5: TLabel;
    ESNum: TEdit;
    Label6: TLabel;
    ECRC: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    EUsr1: TEdit;
    EUsr2: TEdit;
    ExitB: TButton;
    MUtilites: TMenuItem;
    MWrUsrBytes: TMenuItem;
    Timer1: TTimer;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    MRdROM: TMenuItem;
    N4: TMenuItem;
    MStart: TMenuItem;
    N5: TMenuItem;
    GroupBox1: TGroupBox;
    Panel3: TPanel;
    Label4: TLabel;
    TEd4: TLabel;
    TEd3: TLabel;
    TEd1: TLabel;
    TEd2: TLabel;
    TEd0: TLabel;
    cbStart: TCheckBox;
    cbConfig: TComboBox;
    Label1: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MCOM1Click(Sender: TObject);
    procedure MClosePortClick(Sender: TObject);
    procedure MExitClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure MWrUsrBytesClick(Sender: TObject);
    procedure MAboutClick(Sender: TObject);
    procedure EUsr1Exit(Sender: TObject);
    procedure EUsr1KeyPress(Sender: TObject; var Key: Char);
    procedure EUsr2Exit(Sender: TObject);
    procedure EUsr2KeyPress(Sender: TObject; var Key: Char);
    procedure MCircuitClick(Sender: TObject);
    procedure MRdROMClick(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure UpDown2Click(Sender: TObject; Button: TUDBtnType);
    procedure MStartClick(Sender: TObject);
    procedure cbStartClick(Sender: TObject);
    procedure MPortClick(Sender: TObject);
    procedure cbConfigChange(Sender: TObject);
  private
    { Private declarations }
    function  ReadParams:Boolean;
    procedure PClear;
    procedure Open_COM(n:Integer);
    procedure DisableControls;
    procedure ReadConfig;
    procedure SaveConfig;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  Usr1,Usr2,Usr3: Byte;
  Fam: Byte;

  function ConvD(Ch:Char):Integer;
  function HConvert(E:TEdit; var H:Byte):Boolean;

implementation

uses DS1820_Sch;

{$R *.DFM}

Const
//  ResBR=10473;   //Reset Baud Rate (non-standard, to speed up)
  ResBR=9600;    //Reset Baud Rate
  SltBR=115200;  //Time slot Baud Rate

var
  UsedCOM, InitCOM: Integer;
  Phase: Byte;
  CRC: Byte;
  Present: Boolean;
  CurrentPath: String;

//---------------------------- DLL header: ----------------------------------

function AccessCOM(P:PChar):boolean;
 stdcall; external 'comapi32.dll';
function OpenCOM(P:PChar):boolean;
 stdcall; external 'comapi32.dll';
function CloseCOM:boolean;
 stdcall; external 'comapi32.dll';
function SetCOM(baud:DWORD;
                bsize,parity,
                sbits:BYTE):boolean;
 stdcall; external 'comapi32.dll';
function SetModCOM(baud:DWORD;bsize,parity,
                sbits:BYTE;DTR,
                RTS:boolean):boolean;
 stdcall; external 'comapi32.dll';
function SetCOMTo(RdIvl,RdTotM,RdTotC,
          WrTotM,WrTotC:DWORD):boolean;
 stdcall; external 'comapi32.dll';
function SetCOMBuff(RdBuff,
                    WrBuff:DWORD):boolean;
 stdcall; external 'comapi32.dll';
function EscFuncCOM(F:DWORD):boolean;
 stdcall; external 'comapi32.dll';
function GetModem(var lpD:DWORD):boolean;
 stdcall; external 'comapi32.dll';
function PurgeCOM:boolean;
 stdcall; external 'comapi32.dll';
function FlushCOM:boolean;
 stdcall; external 'comapi32.dll';
function TxByteCOM(data:byte):boolean;
 stdcall; external 'comapi32.dll';
function TxDataCOM(const Buffer; N:DWORD;
                   var lpNDone:DWORD):boolean;
 stdcall; external 'comapi32.dll';
function RxDataCOM(var Buffer; N:DWORD;
                   var lpNDone:DWORD):boolean;
 stdcall; external 'comapi32.dll';
function ClrErrCOM(var lpE:DWORD):boolean;
 stdcall; external 'comapi32.dll';

//---------------------------------------------------------------------------
//---------------------------- Procedures -----------------------------------
//---------------------------------------------------------------------------

//-------------------------- Read ini-file: ---------------------------------

procedure TMainForm.ReadConfig;
var
 RegKey: TIniFile;
 FileName: string;
begin
 FileName := ExtractFilePath(Application.EXEName) +
             ChangeFileExt(ExtractFileName(Application.EXEName),'.ini');
 RegKey := TIniFile.Create(FileName);
 with RegKey do
  begin
   MainForm.Left:=ReadInteger('General','Left',221);
   MainForm.Top :=ReadInteger('General','Top',180);
   InitCOM      :=ReadInteger('General','COM port',2);
   Free;
  end;
end;

//------------------------- Write ini-file: ---------------------------------

procedure TMainForm.SaveConfig;
var
 RegKey: TIniFile;
 FileName: string;
begin
 FileName := ExtractFilePath(Application.EXEName) +
             ChangeFileExt(ExtractFileName(Application.EXEName),'.ini');
 RegKey := TIniFile.Create(FileName);
 with RegKey do
  begin
   WriteInteger('General','Left',MainForm.Left);
   WriteInteger('General','Top',MainForm.Top);
   WriteInteger('General','COM port',InitCOM);
   Free;
  end;
end;


//---------------------------- Open COM: ------------------------------------

procedure TMainForm.Open_COM(n:Integer);
var i: Integer;
begin
 CloseCom; UsedCOM:=0;
 for i:=1 to 4 do MainMenu1.Items[0].Items[i-1].Checked:=false;
 DisableControls;
 if n=0 then exit;
 if OpenCom(PChar('COM'+Chr(n+$30)))
  then
   begin
    UsedCOM:=n;
    MainMenu1.Items[0].Items[n-1].Checked:=true;
    MClosePort.Enabled:=true;
    Caption:=Application.Title+' on COM'+Chr(n+$30);
    SetCOMTo(MAXDWORD,0,0,0,0);
    cbStart.Enabled:=true;
    MRdROM.Enabled:=true;
    MStart.Enabled:=true;
    Screen.Cursor:=crHourGlass;
    if not ReadParams
     then
      begin
       Screen.Cursor:=crDefault;
       MessageDlg('Device is not found on COM'+Chr(n+$30)+'.',
                mtError,[mbOk],0);
       PClear;
      end;
    Screen.Cursor:=crDefault;
   end
  else
    MessageDlg('Port COM'+Chr(n+$30)+' is not available.',
                mtError,[mbOk],0);
end;

//------------------------- Disable controls: -------------------------------

procedure TMainForm.DisableControls;
begin
 Timer1.Enabled:=false;
 cbStart.Enabled:=false;
 cbStart.Checked:=false;
 UpDOwn1.Enabled:=false;
 UpDOwn2.Enabled:=false;
 EUsr1.Enabled:=false;
 EUsr2.Enabled:=false;
 MClosePort.Enabled:=false;
 MRdROM.Enabled:=false;
 MStart.Enabled:=false;
 MWrUsrBytes.Enabled:=false;
 Caption:=Application.Title;
 cbConfig.Enabled:=false;
end;

//------------- Clear device ID, serial number, user bytes: -----------------

procedure TMainForm.PClear;
begin
 EID.Text:=''; EID.Refresh;
 EName.Text:='NO DEVICE';  EName.Refresh;
 ESnum.Text:='';  ESnum.Refresh;
 ECRC.Text:='';  ECRC.Refresh;
 EUsr1.Text:='';  EUsr1.Refresh;
 EUsr2.Text:='';  EUsr2.Refresh;
 TEd0.Caption:='';
 TEd1.Caption:='-';
 TEd2.Caption:='-';
 TEd4.Caption:='-'; Panel3.Refresh;
end;

//---------------------- Convert HEX digit to BIN: --------------------------

function ConvD(Ch:Char):Integer;
begin
 case Ch of
 '0'..'9': Result:=Ord(Ch)-$30;
 'A'..'F': Result:=Ord(Ch)-$37;
 else Result:=-1;
 end;
end;

//------------------------- Convert HEX to BIN: -----------------------------

function HConvert(E:TEdit; var H:Byte):Boolean;
var Hp:Byte; S:String; Error:Boolean;
begin
 Hp:=H; Result:=true;
 Error:=false;
 S:=UpperCase(E.Text);
 case length(S) of
 1: if ConvD(S[1])>=0 then H:=ConvD(S[1])
                     else Error:=true;
 2: begin
    if ConvD(S[1])>=0 then H:=ConvD(S[1])
                     else Error:=true;
    if S[2]<>'H'
     then if ConvD(S[2])>=0
           then H:=16*H+ConvD(S[2])
           else Error:=true;
    end;
 3: begin
    if ConvD(S[1])>=0 then H:=ConvD(S[1])
                     else Error:=true;
    if ConvD(S[2])>=0 then H:=16*H+ConvD(S[2])
                     else Error:=true;
    if S[3]<>'H' then Error:=true;
    end;
 else Error:=True;
 end;
 if Error
  then
   begin
   MessageBeep(MB_IconError);
   MessageDlg('Invalid HEX value !',mtError,[mbOK],0);
   H:=Hp;
   E.SetFocus; E.SelectAll;
   Result:=false;
   end;
   E.Text:=Format('%.2xH',[H]);
end;

//---------------------------------------------------------------------------
//---------------------------- 1-Wire I/O -----------------------------------
//---------------------------------------------------------------------------

//--------------------------- Touch Reset: ----------------------------------

function TReset:Boolean;
var
 B:Byte;
 D,time:DWord;
begin
 Result:=False;
 SetModCom(ResBR,8,NOPARITY,ONESTOPBIT,true,false);
 PurgeCom;
 TxByteCOM($F0);
 time:=GetTickCount+50;
 repeat RxDataCOM(B,1,D)
  until (D=1) or (time<GetTickCount);
 if D=1
  then Result:=(B<>$F0);
 Present:=Result;
end;

//---------------------------- Touch Byte: ----------------------------------

function TByte(X:Byte):Byte;
var
 n:Integer;
 B:Byte;
 D,time:DWord;
begin
 Result:=$FF;
 SetModCom(SltBR,8,NOPARITY,ONESTOPBIT,true,false);
 PurgeCom;
 time:=GetTickCount+50;
 for n:=1 to 8 do
  begin
   if Odd(X) then TxByteCOM($FF) else TxByteCOM($00);
   X:=X shr 1;
   repeat RxDataCOM(B,1,D)
   until (D=1) or (time<GetTickCount);
   if D<>1 then exit;
   if Odd(B) then X:=X or $80;
   if Odd(B xor CRC)
    then CRC:=((CRC xor $18) shr 1) or $80
    else CRC:=CRC shr 1;
  end;
  Result:=X;
end;

//---------------------------- Read device: ---------------------------------

function TMainForm.ReadParams:Boolean;
var
 B1,B2,B3,B4,B5,B6:Byte;
begin
 Result:=false;
 Fam := 0;
 cbConfig.Enabled := false;
 PClear;
 if not TReset then exit;
 Result:=true;
 TByte($33); //Read ROM
 CRC:=0;
 Fam:=TByte($FF); B1:=TByte($FF);
 B2:=TByte($FF); B3:=TByte($FF);
 B4:=TByte($FF); B5:=TByte($FF);
 B6:=TByte($FF); TByte($FF);

 EID.Text:=Format('%.2xH',[Fam]);
 Case Fam of
  $01: EName.Text:='DS1990A';
  $02: EName.Text:='DS1991L';
  $04: EName.Text:='DS1994L';
  $06: EName.Text:='DS1993L';
  $08: EName.Text:='DS1992L';
  $09: EName.Text:='DS1982';
  $0A: EName.Text:='DS1995L';
  $0B: EName.Text:='DS1985';
  $0C: EName.Text:='DS1996L';
  $0F: EName.Text:='DS1986';
  $10: if (B6*256+B5)>=8
        then EName.Text:='DS18S20'
        else EName.Text:='DS1820';
  $12: EName.Text:='DS2604';
  $1A: EName.Text:='DS1963L';
  $21: EName.Text:='DS1921';
  $22: EName.Text:='DS1822';
  $28: EName.Text:='DS18B20';
  $33: EName.Text:='DS1961S';
  $41: EName.Text:='DS1922L';
  $89: EName.Text:='DS1982U';
  $8B: EName.Text:='DS1985U';
  $8F: EName.Text:='DS1986U';
  else EName.Text:='UNKNOWN';
 end;
 ESnum.Text:=Format('%.2x%.2x%.2x%.2x%.2x%.2xH',
                    [B6,B5,B4,B3,B2,B1]);
 if CRC=0 then ECRC.Text:='OK' else ECRC.Text:='FAIL';

 if not TReset then exit;
 TByte($CC); //Skip ROM
 TByte($B8); //Recall EEPROM

 if not TReset then exit;
 TByte($CC); //Skip ROM
 TByte($BE); //Read Scratchpad
 TByte($FF); TByte($FF);
 Usr1:=TByte($FF); Usr2:=TByte($FF);
 if Fam=$28 then Usr3:=(TByte($FF) shr 5) and 3;
 EUsr1.Text:=Format('%.2xH',[Usr1]);
 EUsr2.Text:=Format('%.2xH',[Usr2]);
 if Fam=$28 then cbConfig.ItemIndex := Usr3;
 UpDOwn1.Position:=Usr1;
 UpDOwn2.Position:=Usr2;
 UpDown1.Enabled:=true;
 UpDown2.Enabled:=true;
 EUsr1.Enabled:=true;
 EUsr2.Enabled:=true;
 MWrUsrBytes.Enabled:=true;
end;

//---------------------------------------------------------------------------
//---------------------------- Form Show ------------------------------------
//---------------------------------------------------------------------------

procedure TMainForm.FormShow(Sender: TObject);
var n: Integer;
begin
 CurrentPath:=ExtractFilePath(ParamStr(0));
 Caption:=Application.Title;
 ReadConfig;
 Fam := 0;
 for n:=1 to 4 do
   MainMenu1.Items[0].Items[n-1].Enabled:=
        AccessCom(PChar('COM'+Chr(n+$30)));
 Present:=false; PClear;
 Open_COM(InitCOM);
end;

//---------------------------------------------------------------------------
//---------------------------- Form Close -----------------------------------
//---------------------------------------------------------------------------

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Timer1.Enabled:=False;
 InitCOM:=UsedCOM;
 SaveConfig;
 CloseCOM; UsedCOM:=0;
end;

//---------------------------------------------------------------------------
//------------------------------ Menus --------------------------------------
//---------------------------------------------------------------------------

//---------------------------- Menu Port: -----------------------------------

procedure TMainForm.MPortClick(Sender: TObject);
var n: Integer;
begin
   for n:=1 to 4 do
    if UsedCOM<>n then
     MainMenu1.Items[0].Items[n-1].Enabled:=
       AccessCom(PChar('COM'+Chr(n+$30)));
end;

//-------------------------- Menu Port Open: --------------------------------

procedure TMainForm.MCOM1Click(Sender: TObject);
var n:Integer;
begin
 n:=0;
 if Sender=MainMenu1.Items[0].Items[0] then n:=1;
 if Sender=MainMenu1.Items[0].Items[1] then n:=2;
 if Sender=MainMenu1.Items[0].Items[2] then n:=3;
 if Sender=MainMenu1.Items[0].Items[3] then n:=4;
 if UsedCOM<>n
  then Open_COM(n);
end;

//-------------------------- Menu Port Close --------------------------------

procedure TMainForm.MClosePortClick(Sender: TObject);
var i:Integer;
begin
 CloseCom; UsedCOM:=0;
 for i:=1 to 4 do MainMenu1.Items[0].Items[i-1].Checked:=false;
 DisableControls;
 PClear;
end;

//---------------------------- Menu Exit: -----------------------------------

procedure TMainForm.MExitClick(Sender: TObject);
begin
 Close;
end;

//--------------------------- Menu Read ROM: --------------------------------

procedure TMainForm.MRdROMClick(Sender: TObject);
begin
 Screen.Cursor:=crHourGlass;
 if not ReadParams then
  begin
   Screen.Cursor:=crDefault;
   MessageDlg('Device is not found on COM'+Chr(UsedCOM+$30)+'.',
             mtError,[mbOk],0);
   PClear;
  end;
 Phase:=0;
 Screen.Cursor:=crDefault;
end;

//---------------------------- Menu Start: ----------------------------------

procedure TMainForm.MStartClick(Sender: TObject);
begin
 cbStart.Checked:=not cbStart.Checked;
 cbStartClick(nil);
end;

procedure TMainForm.cbStartClick(Sender: TObject);
begin
 cbStart.Refresh;
 MStart.Checked:=cbStart.Checked;
 if cbStart.Checked then
  begin
   Phase:=0;
   Timer1.Enabled:=True;
  end
   else
    begin
     Timer1.Enabled:=False;
     TEd0.Caption:='';
     TEd1.Caption:='-';
     TEd2.Caption:='-';
     TEd4.Caption:='-';
    end;
end;

//---------------------- Menu Write User Bytes: -----------------------------

procedure TMainForm.MWrUsrBytesClick(Sender: TObject);
begin
 if MessageDlg('Write User Bytes To EEPROM ?'
               ,mtConfirmation,[mbYes,mbNo],0) = mrYes
  then
   begin
    Screen.Cursor:=crHourGlass;

    if not TReset
     then
      begin
       Screen.Cursor:=crDefault;
       MessageDlg('Device is not found on COM'+
                 Chr(UsedCOM+$30)+'.',mtError,[mbOk],0);
       PClear;
       exit;
      end;

    TByte($CC); //Skip ROM
    TByte($4E); //Write Scratchpad
    TByte(Usr1);
    TByte(Usr2);
    if Fam=$28 then TByte(Usr3 shl 5);

    TReset;
    TByte($CC); //Skip ROM
    TByte($48); //Copy Scratchpad
    Sleep(20);

    TReset;
    TByte($CC); //Skip ROM
    TByte($B8); //Recall EEPROM

    TReset;
    TByte($CC); //Skip ROM
    TByte($BE); //Read Scratchpad
    TByte($FF); TByte($FF);
    Usr1:=TByte($FF); Usr2:=TByte($FF);
    if Fam=$28 then Usr3 := (TByte($FF) shr 5) and 3;

    EUsr1.Text:=Format('%.2xH',[Usr1]);
    EUsr2.Text:=Format('%.2xH',[Usr2]);
    if Fam=$28 then cbConfig.ItemIndex := Usr3;
    Phase:=0;
    Screen.Cursor:=crDefault;
   end;
end;

//---------------------------- Menu Circuit: --------------------------------

procedure TMainForm.MCircuitClick(Sender: TObject);
begin
 SchForm.ShowModal;
end;

//----------------------------- Menu About: ---------------------------------

procedure TMainForm.MAboutClick(Sender: TObject);
begin
 MessageDlg('DS1820 / DS18S20 / DS18B20 thermometer.'+#13+
            'E-mail: wubblick@yahoo.com.'
               ,mtInformation,[mbOk],0);
end;

//---------------------------------------------------------------------------
//------------------------- Edit user bytes ---------------------------------
//---------------------------------------------------------------------------

//----------------------------- Edit USR1: ----------------------------------

procedure TMainForm.EUsr1KeyPress(Sender: TObject; var Key: Char);
begin
 if Key=#13 then
  begin
   HConvert(EUsr1,Usr1);
   UpDOwn1.Position:=Usr1;
   Key:=#0;
   EUsr1.SelectAll;
  end;
 if Key=#27 then
  begin
   EUsr1.Text:=Format('%.2xH',[Usr1]);
   Key:=#0;
   EUsr1.SelectAll;
  end;
end;

procedure TMainForm.EUsr1Exit(Sender: TObject);
begin
 HConvert(EUsr1,Usr1);
 UpDOwn1.Position:=Usr1;
end;

procedure TMainForm.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
 Usr1:=UpDOwn1.Position;
 EUsr1.Text:=Format('%.2xH',[Usr1]);
end;

//----------------------------- Edit USR2: ----------------------------------

procedure TMainForm.EUsr2KeyPress(Sender: TObject; var Key: Char);
begin
 if Key=#13 then
  begin
   HConvert(EUsr2,Usr2);
   UpDOwn2.Position:=Usr2;
   Key:=#0;
   EUsr2.SelectAll;
  end;
 if Key=#27 then
  begin
   EUsr2.Text:=Format('%.2xH',[Usr2]);
   Key:=#0;
   EUsr2.SelectAll;
  end;
end;

procedure TMainForm.EUsr2Exit(Sender: TObject);
begin
 HConvert(EUsr2,Usr2);
 UpDOwn2.Position:=Usr2;
end;

procedure TMainForm.UpDown2Click(Sender: TObject; Button: TUDBtnType);
begin
 Usr2:=UpDOwn2.Position;
 EUsr2.Text:=Format('%.2xH',[Usr2]);
end;

//----------------------------- Edit USR3: ----------------------------------

procedure TMainForm.cbConfigChange(Sender: TObject);
begin
 Usr3:=cbConfig.ItemIndex;
end;

//---------------------------------------------------------------------------
//------------------------------ Timer --------------------------------------
//---------------------------------------------------------------------------

procedure TMainForm.Timer1Timer(Sender: TObject);
var TH,TL,CR,CP:Byte;
    TEMP_READ: Smallint;
    Temp: double;
    T: integer;
begin
 Phase:=Phase+1;
 case Phase of
    1: if not TReset
        then
         begin
          TEd0.Caption:='';
          TEd1.Caption:='-';
          TEd2.Caption:='-';
          TEd4.Caption:='-';
          Phase:=0;
         end;
    2: begin
        TByte($CC); //Skip ROM
        TByte($44); //Start T Convert
       end;
    5: if (not Present) or (not TReset)
        then
         begin
          TEd0.Caption:='';
          TEd1.Caption:='-';
          TEd2.Caption:='-';
          TEd4.Caption:='-';
          Phase:=0;
         end;
    6: begin
        TByte($CC); //Skip ROM
        TByte($BE); //Read Scratchpad
        TL:=TByte($FF); TH:=TByte($FF);
        TByte($FF); TByte($FF);
        TByte($FF); TByte($FF);
        CR:=TByte($FF); CP:=TByte($FF);
        TEMP_READ := TL + 256 * TH;
        if Fam=$28 then
         begin
          Temp := TEMP_READ / 16.0;
         end
        else
         begin
          Temp := TRUNC(TEMP_READ / 2) - 0.25 + (CP - CR) / CP;
         end;
        T := ROUND(Temp * 10.0);
        if T < 0 then begin T := -T; TEd0.Caption:='-'; end
         else TEd0.Caption:='';
        if T>999 then T:=999;
        TH:=T div 100; T:=T mod 100;
        TL:=T div 10; CR:=T mod 10;
        if TH=0 then TEd1.Caption:='' else
        TEd1.Caption:=IntToStr(TH);
        TEd2.Caption:=IntToStr(TL);
        TEd4.Caption:=IntToStr(CR);
        Phase:=0;
       end;
 end;
end;

//---------------------------------------------------------------------------

end.
